Index: src/XmlRpc.h
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpc.h,v
retrieving revision 1.7
diff -u -r1.7 XmlRpc.h
--- src/XmlRpc.h	29 Apr 2003 01:06:21 -0000	1.7
+++ src/XmlRpc.h	21 Aug 2003 18:42:34 -0000
@@ -28,12 +28,12 @@
 # include <string>
 #endif
 
-#include "XmlRpcClient.h"
-#include "XmlRpcException.h"
-#include "XmlRpcServer.h"
-#include "XmlRpcServerMethod.h"
-#include "XmlRpcValue.h"
-#include "XmlRpcUtil.h"
+#include <xmlrpcpp/XmlRpcClient.h>
+#include <xmlrpcpp/XmlRpcException.h>
+#include <xmlrpcpp/XmlRpcServer.h>
+#include <xmlrpcpp/XmlRpcServerMethod.h>
+#include <xmlrpcpp/XmlRpcValue.h>
+#include <xmlrpcpp/XmlRpcUtil.h>
 
 namespace XmlRpc {
 
Index: src/XmlRpcClient.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpcClient.cpp,v
retrieving revision 1.8
diff -u -r1.8 XmlRpcClient.cpp
--- src/XmlRpcClient.cpp	6 Jun 2003 18:14:16 -0000	1.8
+++ src/XmlRpcClient.cpp	21 Aug 2003 18:42:34 -0000
@@ -72,7 +72,7 @@
 
 XmlRpcClient::~XmlRpcClient()
 {
-  XmlRpcUtil::log(1, "XmlRpcClient dtor client: host %s, port %d.", _host, _port);
+  XmlRpcUtil::log(1, "XmlRpcClient dtor client: host %s, port %d.", _host.c_str(), _port);
   if (_connectionState != NO_CONNECTION) close();
 }
 
Index: src/XmlRpcClient.h
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpcClient.h,v
retrieving revision 1.7
diff -u -r1.7 XmlRpcClient.h
--- src/XmlRpcClient.h	29 Apr 2003 00:02:57 -0000	1.7
+++ src/XmlRpcClient.h	21 Aug 2003 18:42:34 -0000
@@ -13,8 +13,8 @@
 # include <string>
 #endif
 
-#include "XmlRpcDispatch.h"
-#include "XmlRpcSource.h"
+#include <xmlrpcpp/XmlRpcDispatch.h>
+#include <xmlrpcpp/XmlRpcSource.h>
 
 namespace XmlRpc {
 
Index: src/XmlRpcServer.h
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpcServer.h,v
retrieving revision 1.10
diff -u -r1.10 XmlRpcServer.h
--- src/XmlRpcServer.h	8 May 2003 01:21:35 -0000	1.10
+++ src/XmlRpcServer.h	21 Aug 2003 18:42:34 -0000
@@ -13,8 +13,8 @@
 # include <string>
 #endif
 
-#include "XmlRpcDispatch.h"
-#include "XmlRpcSource.h"
+#include <xmlrpcpp/XmlRpcDispatch.h>
+#include <xmlrpcpp/XmlRpcSource.h>
 
 namespace XmlRpc {
 
Index: src/XmlRpcServerConnection.h
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpcServerConnection.h,v
retrieving revision 1.5
diff -u -r1.5 XmlRpcServerConnection.h
--- src/XmlRpcServerConnection.h	29 Apr 2003 01:06:24 -0000	1.5
+++ src/XmlRpcServerConnection.h	21 Aug 2003 18:42:34 -0000
@@ -11,8 +11,8 @@
 # include <string>
 #endif
 
-#include "XmlRpcValue.h"
-#include "XmlRpcSource.h"
+#include <xmlrpcpp/XmlRpcValue.h>
+#include <xmlrpcpp/XmlRpcSource.h>
 
 namespace XmlRpc {
 
Index: src/XmlRpcThreadedServer.h
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/src/XmlRpcThreadedServer.h,v
retrieving revision 1.2
diff -u -r1.2 XmlRpcThreadedServer.h
--- src/XmlRpcThreadedServer.h	29 Apr 2003 01:06:25 -0000	1.2
+++ src/XmlRpcThreadedServer.h	21 Aug 2003 18:42:35 -0000
@@ -14,9 +14,9 @@
 #endif
 
 
-#include "XmlRpcMutex.h"
-#include "XmlRpcServer.h"
-#include "XmlRpcThread.h"
+#include <xmlrpcpp/XmlRpcMutex.h>
+#include <xmlrpcpp/XmlRpcServer.h>
+#include <xmlrpcpp/XmlRpcThread.h>
 
 
 namespace XmlRpc {

Index: test/FileClient.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/FileClient.cpp,v
retrieving revision 1.2
diff -u -r1.2 FileClient.cpp
--- test/FileClient.cpp	13 Feb 2003 04:01:16 -0000	1.2
+++ test/FileClient.cpp	21 Aug 2003 18:42:35 -0000
@@ -3,7 +3,7 @@
 // 
 // Link against xmlrpc lib and whatever socket libs your system needs (ws2_32.lib on windows)
 
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 #include <iostream>
 #include <fstream>
 #include <stdlib.h>

Index: test/HelloClient.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/HelloClient.cpp,v
retrieving revision 1.7
diff -u -r1.7 HelloClient.cpp
--- test/HelloClient.cpp	6 Mar 2003 16:26:26 -0000	1.7
+++ test/HelloClient.cpp	21 Aug 2003 18:42:35 -0000
@@ -1,7 +1,7 @@
 // HelloClient.cpp : A simple xmlrpc client. Usage: HelloClient serverHost serverPort
 // Link against xmlrpc lib and whatever socket libs your system needs (ws2_32.lib 
 // on windows)
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 #include <iostream>
 using namespace XmlRpc;
 
Index: test/HelloServer.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/HelloServer.cpp,v
retrieving revision 1.6
diff -u -r1.6 HelloServer.cpp
--- test/HelloServer.cpp	5 Mar 2003 21:59:48 -0000	1.6
+++ test/HelloServer.cpp	21 Aug 2003 18:42:35 -0000
@@ -1,6 +1,6 @@
 // HelloServer.cpp : Simple XMLRPC server example. Usage: HelloServer serverPort
 //
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 
 #include <iostream>
 #include <stdlib.h>

Index: test/TestBase64Client.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/TestBase64Client.cpp,v
retrieving revision 1.3
diff -u -r1.3 TestBase64Client.cpp
--- test/TestBase64Client.cpp	6 Mar 2003 00:29:56 -0000	1.3
+++ test/TestBase64Client.cpp	21 Aug 2003 18:42:35 -0000
@@ -5,7 +5,7 @@
 // Requests a png file from the specified server and saves it in outputfile.
 // Link against xmlrpc lib and whatever socket libs your system needs (ws2_32.lib on windows)
 
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 #include <iostream>
 #include <fstream>
 #include <stdlib.h>

Index: test/TestBase64Server.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/TestBase64Server.cpp,v
retrieving revision 1.2
diff -u -r1.2 TestBase64Server.cpp
--- test/TestBase64Server.cpp	13 Feb 2003 04:01:20 -0000	1.2
+++ test/TestBase64Server.cpp	21 Aug 2003 18:42:35 -0000
@@ -11,7 +11,7 @@
 #include <stdlib.h>
 
 
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 using namespace XmlRpc;
 
 

Index: test/TestValues.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/TestValues.cpp,v
retrieving revision 1.5
diff -u -r1.5 TestValues.cpp
--- test/TestValues.cpp	24 Feb 2003 16:10:49 -0000	1.5
+++ test/TestValues.cpp	21 Aug 2003 18:42:35 -0000
@@ -2,7 +2,7 @@
 
 #include <stdlib.h>
 
-#include "XmlRpcValue.h"
+#include <xmlrpcpp/XmlRpcValue.h>
 
 
 #include <assert.h>

Index: test/TestXml.cpp
===================================================================
RCS file: /cvsroot/xmlrpcpp/xmlrpc++/test/TestXml.cpp,v
retrieving revision 1.2
diff -u -r1.2 TestXml.cpp
--- test/TestXml.cpp	13 Feb 2003 04:01:22 -0000	1.2
+++ test/TestXml.cpp	21 Aug 2003 18:42:35 -0000
@@ -11,7 +11,7 @@
 #include <assert.h>
 #include <stdlib.h>
 
-#include "XmlRpcUtil.h"
+#include <xmlrpcpp/XmlRpcUtil.h>
 
 using namespace XmlRpc;
 

--- /dev/null	1970-01-01 01:00:00.000000000 +0100
+++ autogen.sh	2003-08-16 21:22:03.000000000 +0200
@@ -0,0 +1,14 @@
+#!/bin/sh
+
+rm -f config.cache
+rm -f acconfig.h
+touch acconfig.h
+aclocal
+libtoolize -f
+autoconf -f 
+autoheader
+#acconfig
+automake -a -v -c --force-missing --add-missing
+#exit
+
+#./configure --enable-shared=no $*
--- /dev/null	1970-01-01 01:00:00.000000000 +0100
+++ configure.in	2003-08-20 19:42:22.000000000 +0200
@@ -0,0 +1,44 @@
+AC_INIT(README.html)
+AC_PROG_CC
+AC_PROG_CXX
+AC_LANG_CPLUSPLUS
+AC_PROG_INSTALL
+AC_PROG_MAKE_SET
+AC_CONFIG_HEADERS
+AC_CANONICAL_HOST
+AC_CANONICAL_TARGET
+AC_FUNC_ALLOCA
+AC_ARG_PROGRAM
+AC_PROG_LIBTOOL
+XMLRPC_MAJOR_VERSION=0 
+XMLRPC_MINOR_VERSION=7
+XMLRPC_MICRO_VERSION=0 
+
+#shared library versioning
+XMLRPC_INTERFACE_AGE=0 # increment if interfaces have been added, zero if interfaces have changed or been removed 
+XMLRPC_BINARY_AGE=0    # increment if binary-compatability is broken
+
+XMLRPC_VERSION=$XMLRPC_MAJOR_VERSION.$XMLRPC_MINOR_VERSION.$XMLRPC_MICRO_VERSION
+
+LT_RELEASE=$XMLRPC_MAJOR_VERSION.$XMLRPC_MINOR_VERSION
+LT_CURRENT=`expr $XMLRPC_MICRO_VERSION - $XMLRPC_INTERFACE_AGE`
+LT_REVISION=$XMLRPC_INTERFACE_AGE
+LT_AGE=`expr $XMLRPC_BINARY_AGE - $XMLRPC_INTERFACE_AGE`
+
+AC_SUBST(LT_RELEASE)
+AC_SUBST(LT_CURRENT)
+AC_SUBST(LT_REVISION)
+AC_SUBST(LT_AGE)
+AC_SUBST(XMLRPC_VERSION)
+
+AM_INIT_AUTOMAKE(libxmlrpcpp,$XMLRPC_VERSION)
+
+PACKAGE="libxmlrpcpp"
+VERSION="$XMLRPC_VERSION"
+
+
+AC_OUTPUT([
+Makefile 
+xmlrpcpp/Makefile
+test/Makefile
+])
--- /dev/null	1970-01-01 01:00:00.000000000 +0100
+++ Makefile.am	2003-08-20 19:49:54.000000000 +0200
@@ -0,0 +1,3 @@
+SUBDIRS = xmlrpcpp test
+
+
--- /dev/null	1970-01-01 01:00:00.000000000 +0100
+++ src/Makefile.am	2003-08-17 14:58:34.000000000 +0200
@@ -0,0 +1,23 @@
+INCLUDES = -I$(top_srcdir)/
+
+lib_LTLIBRARIES = libxmlrpcpp.la
+
+libxmlrpcpp_la_LDFLAGS = -version-info $(LT_CURRENT):$(LT_REVISION):$(LT_AGE)
+
+
+library_includedir = $(includedir)/xmlrpc++-$(LT_RELEASE)/xmlrpcpp
+
+library_include_HEADERS = 	XmlRpc.h XmlRpcServer.h XmlRpcSocket.h XmlRpcValue.h \
+				XmlRpcClient.h XmlRpcServerConnection.h XmlRpcSource.h \
+				base64.h XmlRpcDispatch.h XmlRpcServerMethod.h XmlRpcUtil.h \
+				XmlRpcThreadedServer.h XmlRpcException.h XmlRpcMutex.h XmlRpcThread.h
+
+libxmlrpcpp_la_SOURCES = $(XMLRPC_SOURCE)
+
+
+XMLRPC_SOURCE = XmlRpcClient.cpp XmlRpcServerConnection.cpp XmlRpcSource.cpp \
+		XmlRpcDispatch.cpp XmlRpcServerMethod.cpp XmlRpcUtil.cpp \
+		XmlRpcServer.cpp XmlRpcSocket.cpp XmlRpcValue.cpp \
+		XmlRpcThreadedServer.cpp XmlRpcMutex.cpp\
+		XmlRpcThread.cpp 
+
--- /dev/null	1970-01-01 01:00:00.000000000 +0100
+++ test/Makefile.am	2003-08-20 19:52:10.000000000 +0200
@@ -0,0 +1,15 @@
+INCLUDES = -I$(top_srcdir) 
+check_PROGRAMS = HelloClient HelloServer \
+		TestXml TestValues FileClient \
+		TestBase64Client TestBase64Server \
+		Validator
+
+HelloClient_SOURCES = HelloClient.cpp
+HelloServer_SOURCES = HelloServer.cpp
+TestXml_SOURCES = TestXml.cpp
+TestValues_SOURCES = TestValues.cpp
+FileClient_SOURCES = FileClient.cpp
+TestBase64Client_SOURCES = TestBase64Client.cpp
+TestBase64Server_SOURCES = TestBase64Server.cpp
+Validator_SOURCES = Validator.cpp
+AM_LDFLAGS=$(top_srcdir)/xmlrpcpp/libxmlrpcpp.la
--- ../Validator.cpp	2003-08-21 21:38:16.000000000 +0200
+++ test/Validator.cpp	2003-08-21 21:37:25.000000000 +0200
@@ -1,6 +1,6 @@
 // Validator.cpp : XMLRPC server based on the compliancy test at validator.xmlrpc.com.
 //
-#include "XmlRpc.h"
+#include <xmlrpcpp/XmlRpc.h>
 using namespace XmlRpc;
 
 #include <iostream>