Index: build/build_make-debug.sh
===================================================================
--- build/build_make-debug.sh	(revision 0)
+++ build/build_make-debug.sh	(revision 0)
@@ -0,0 +1,2 @@
+#!/bin/sh
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Debug
Index: build/build_make-release.sh
===================================================================
--- build/build_make-release.sh	(revision 0)
+++ build/build_make-release.sh	(revision 0)
@@ -0,0 +1,2 @@
+#!/bin/sh
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Release
Index: build/build_mingw-debug.bat
===================================================================
--- build/build_mingw-debug.bat	(revision 0)
+++ build/build_mingw-debug.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Debug -G "MinGW Makefiles"
\ No newline at end of file
Index: build/build_mingw-release.bat
===================================================================
--- build/build_mingw-release.bat	(revision 0)
+++ build/build_mingw-release.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Release -G "MinGW Makefiles"
\ No newline at end of file
Index: build/build_nmake-debug.bat
===================================================================
--- build/build_nmake-debug.bat	(revision 0)
+++ build/build_nmake-debug.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Debug -G "NMake Makefiles"
\ No newline at end of file
Index: build/build_nmake-minsizerel.bat
===================================================================
--- build/build_nmake-minsizerel.bat	(revision 0)
+++ build/build_nmake-minsizerel.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=MinSizeRel -G "NMake Makefiles"
\ No newline at end of file
Index: build/build_nmake-release.bat
===================================================================
--- build/build_nmake-release.bat	(revision 0)
+++ build/build_nmake-release.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Release -G "NMake Makefiles"
\ No newline at end of file
Index: build/build_nmake-relwithdebinfo.bat
===================================================================
--- build/build_nmake-relwithdebinfo.bat	(revision 0)
+++ build/build_nmake-relwithdebinfo.bat	(revision 0)
@@ -0,0 +1 @@
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=RelWithDebInfo -G "NMake Makefiles"
\ No newline at end of file
Index: build/build_projectmsvc90-debug.bat
===================================================================
--- build/build_projectmsvc90-debug.bat	(revision 0)
+++ build/build_projectmsvc90-debug.bat	(revision 0)
@@ -0,0 +1,3 @@
+del CMakeCache.txt
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=Debug -G "Visual Studio 9 2008"
+del CMakeCache.txt
Index: build/build_projectmsvc90-relwithdebinfo.bat
===================================================================
--- build/build_projectmsvc90-relwithdebinfo.bat	(revision 0)
+++ build/build_projectmsvc90-relwithdebinfo.bat	(revision 0)
@@ -0,0 +1,3 @@
+del CMakeCache.txt
+cmake .. -DCMAKE_VERBOSE_MAKEFILE=1 -DCMAKE_BUILD_TYPE=RelWithDebInfo -G "Visual Studio 9 2008"
+del CMakeCache.txt
Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 0)
+++ CMakeLists.txt	(revision 0)
@@ -0,0 +1,197 @@
+# Mininum required CMake version
+cmake_minimum_required(VERSION 2.6)
+
+# CMake policy
+cmake_policy(VERSION 2.6.4)
+
+project(cppunit)
+
+# UNICODE support
+# See Visual C++ Unicode Programming Summary
+# http://msdn.microsoft.com/en-us/library/dybsewaf%28VS.100%29.aspx
+#add_definitions(-DUNICODE -D_UNICODE)
+
+# Create a .dll under Windows
+add_definitions(-DCPPUNIT_BUILD_DLL)
+
+include_directories(include)
+
+# CppUnit version number
+set(CPPUNIT_MAJOR_VERSION 1)
+set(CPPUNIT_MINOR_VERSION 11)
+set(CPPUNIT_MICRO_VERSION 6)
+set(CPPUNIT_VERSION ${CPPUNIT_MAJOR_VERSION}.${CPPUNIT_MINOR_VERSION}.${CPPUNIT_MICRO_VERSION})
+##
+
+
+# Generates include/cppunit/config-auto.h
+# This is originally done by autoconf
+
+include(CheckIncludeFile)
+include(CheckIncludeFileCXX)
+include(CheckCXXSourceCompiles)
+include(CheckCSourceCompiles)
+include(CheckLibraryExists)
+include(CheckFunctionExists)
+
+#Not used == not seen in any *.h *.cpp files
+#Not used FUNC_STRING_COMPARE_STRING_FIRST
+
+check_include_file_cxx(sstream CPPUNIT_HAVE_SSTREAM)
+check_include_file_cxx(strstream CPPUNIT_HAVE_STRSTREAM)
+set (CMAKE_REQUIRED_DEFINITIONS -DHAVE_STRSTREAM=CPPUNIT_HAVE_STRSTREAM)
+check_cxx_source_compiles(
+"#ifdef HAVE_STRSTREAM
+#	include <strstream>
+#else
+#	include <strstream.h>
+#endif
+int main() {
+	std::ostrstream message;
+	message << \"Hello\";
+	return 0;
+}" CPPUNIT_HAVE_CLASS_STRSTREAM)
+
+check_include_file_cxx(cmath CPPUNIT_HAVE_CMATH)
+#Not used, dld library is obsolete anyway HAVE_DLD
+#Not used HAVE_DLERROR
+check_include_file(dlfcn.h CPPUNIT_HAVE_DLFCN_H)
+
+check_c_source_compiles(
+"#include <math.h>
+int main() {
+	return finite(3);
+}" CPPUNIT_HAVE_FINITE)
+
+check_c_source_compiles(
+"#include <math.h>
+int main() {
+	return _finite(3);
+}" CPPUNIT_HAVE__FINITE)
+
+check_include_file_cxx(cxxabi.h CPPUNIT_HAVE_GCC_ABI_DEMANGLE)
+#Not used HAVE_INTTYPES_H
+
+check_c_source_compiles(
+"#include <math.h>
+int main() {
+	return isfinite(3);
+}" CPPUNIT_HAVE_ISFINITE)
+
+check_library_exists(dl dlopen "" CPPUNIT_HAVE_LIBDL)
+#Not used HAVE_MEMORY_H
+
+check_cxx_source_compiles(
+"namespace Outer {
+	namespace Inner {
+		int i = 0;
+	}
+}
+using namespace Outer::Inner;
+int main() {
+	return i;
+}" CPPUNIT_HAVE_NAMESPACES)
+
+check_cxx_source_compiles(
+"#include <typeinfo>
+class Base {
+public:
+	Base() {}
+	virtual int f() { return 0; }
+};
+class Derived : public Base {
+public:
+	Derived() {}
+	virtual int f() { return 1; }
+};
+int main() {
+	Derived d;
+	Base * ptr = &d;
+	return typeid(*ptr) == typeid(Derived);
+}" CPPUNIT_HAVE_RTTI)
+
+check_library_exists(dl shl_load "" CPPUNIT_HAVE_SHL_LOAD)
+#Not used HAVE_STDINT_H
+#Not used HAVE_STDLIB_H
+#Not used HAVE_STRINGS_H
+#Not used HAVE_STRING_H
+#Not used HAVE_SYS_STAT_H
+#Not used HAVE_SYS_TYPES_H
+#Not used HAVE_UNISTD_H
+#Not used PACKAGE
+#Not used PACKAGE_BUGREPORT
+#Not used PACKAGE_NAME
+#Not used PACKAGE_STRING
+#Not used PACKAGE_TARNAME
+#Not used PACKAGE_VERSION
+#Not used STDC_HEADERS
+check_include_file_cxx(typeinfo CPPUNIT_USE_TYPEINFO_NAME)
+#CPPUNIT_VERSION ok
+
+configure_file(config/config.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/include/cppunit/config-auto.h)
+##
+
+
+set(cppunit_SRCS
+	src/cppunit/AdditionalMessage.cpp
+	src/cppunit/Asserter.cpp
+	src/cppunit/BeOsDynamicLibraryManager.cpp
+	src/cppunit/BriefTestProgressListener.cpp
+	src/cppunit/CompilerOutputter.cpp
+	src/cppunit/DefaultProtector.h
+	src/cppunit/DefaultProtector.cpp
+	src/cppunit/DynamicLibraryManager.cpp
+	src/cppunit/DynamicLibraryManagerException.cpp
+	src/cppunit/Exception.cpp
+	src/cppunit/Message.cpp
+	src/cppunit/RepeatedTest.cpp
+	src/cppunit/PlugInManager.cpp
+	src/cppunit/PlugInParameters.cpp
+	src/cppunit/Protector.cpp
+	src/cppunit/ProtectorChain.h
+	src/cppunit/ProtectorContext.h
+	src/cppunit/ProtectorChain.cpp
+	src/cppunit/SourceLine.cpp
+	src/cppunit/StringTools.cpp
+	src/cppunit/SynchronizedObject.cpp
+	src/cppunit/Test.cpp
+	src/cppunit/TestAssert.cpp
+	src/cppunit/TestCase.cpp
+	src/cppunit/TestCaseDecorator.cpp
+	src/cppunit/TestComposite.cpp
+	src/cppunit/TestDecorator.cpp
+	src/cppunit/TestFactoryRegistry.cpp
+	src/cppunit/TestFailure.cpp
+	src/cppunit/TestLeaf.cpp
+	src/cppunit/TestNamer.cpp
+	src/cppunit/TestPath.cpp
+	src/cppunit/TestPlugInDefaultImpl.cpp
+	src/cppunit/TestResult.cpp
+	src/cppunit/TestResultCollector.cpp
+	src/cppunit/TestRunner.cpp
+	src/cppunit/TestSetUp.cpp
+	src/cppunit/TestSuccessListener.cpp
+	src/cppunit/TestSuite.cpp
+	src/cppunit/TestSuiteBuilderContext.cpp
+	src/cppunit/TextOutputter.cpp
+	src/cppunit/TextTestProgressListener.cpp
+	src/cppunit/TextTestResult.cpp
+	src/cppunit/TextTestRunner.cpp
+	src/cppunit/TypeInfoHelper.cpp
+	src/cppunit/UnixDynamicLibraryManager.cpp
+	src/cppunit/ShlDynamicLibraryManager.cpp
+	src/cppunit/XmlDocument.cpp
+	src/cppunit/XmlElement.cpp
+	src/cppunit/XmlOutputter.cpp
+	src/cppunit/XmlOutputterHook.cpp
+	src/cppunit/Win32DynamicLibraryManager.cpp
+)
+
+add_library(cppunit SHARED ${cppunit_SRCS})
+
+set_target_properties(cppunit PROPERTIES
+	VERSION ${CPPUNIT_VERSION}
+	SOVERSION ${CPPUNIT_MAJOR_VERSION}
+)
+
+#install(TARGETS cppunit DESTINATION lib)
Index: config/config.h.cmake
===================================================================
--- config/config.h.cmake	(revision 0)
+++ config/config.h.cmake	(revision 0)
@@ -0,0 +1,103 @@
+/* Inspired by config/config.h.in, config.h.cmake is used by CMake. */
+
+/* define if library uses std::string::compare(string,pos,n) */
+//Not used #undef FUNC_STRING_COMPARE_STRING_FIRST
+
+/* define if the library defines strstream */
+#cmakedefine CPPUNIT_HAVE_CLASS_STRSTREAM
+
+/* Define to 1 if you have the <cmath> header file. */
+#cmakedefine CPPUNIT_HAVE_CMATH
+
+/* Define if you have the GNU dld library. */
+//Not used, dld library is obsolete anyway #undef HAVE_DLD
+
+/* Define to 1 if you have the `dlerror' function. */
+//Not used #undef HAVE_DLERROR
+
+/* Define to 1 if you have the <dlfcn.h> header file. */
+#cmakedefine CPPUNIT_HAVE_DLFCN_H
+
+/* Define to 1 if you have the `finite' function. */
+#cmakedefine CPPUNIT_HAVE_FINITE
+
+/* Define to 1 if you have the `_finite' function. */
+#cmakedefine CPPUNIT_HAVE__FINITE
+
+/* define if the compiler supports GCC C++ ABI name demangling */
+#cmakedefine CPPUNIT_HAVE_GCC_ABI_DEMANGLE
+
+/* Define to 1 if you have the <inttypes.h> header file. */
+//Not used #undef HAVE_INTTYPES_H
+
+/* define if compiler has isfinite */
+#cmakedefine CPPUNIT_HAVE_ISFINITE
+
+/* Define if you have the libdl library or equivalent. */
+#cmakedefine CPPUNIT_HAVE_LIBDL
+
+/* Define to 1 if you have the <memory.h> header file. */
+//Not used #undef HAVE_MEMORY_H
+
+/* define to 1 if the compiler implements namespaces */
+#cmakedefine CPPUNIT_HAVE_NAMESPACES
+
+/* define if the compiler supports Run-Time Type Identification */
+#cmakedefine CPPUNIT_HAVE_RTTI
+
+/* Define if you have the shl_load function. */
+#cmakedefine CPPUNIT_HAVE_SHL_LOAD
+
+/* define if the compiler has stringstream */
+#cmakedefine CPPUNIT_HAVE_SSTREAM
+
+/* Define to 1 if you have the <stdint.h> header file. */
+//Not used #undef HAVE_STDINT_H
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+//Not used #undef HAVE_STDLIB_H
+
+/* Define to 1 if you have the <strings.h> header file. */
+//Not used #undef HAVE_STRINGS_H
+
+/* Define to 1 if you have the <string.h> header file. */
+//Not used #undef HAVE_STRING_H
+
+/* Define to 1 if you have the <strstream> header file. */
+#cmakedefine CPPUNIT_HAVE_STRSTREAM
+
+/* Define to 1 if you have the <sys/stat.h> header file. */
+//Not used #undef HAVE_SYS_STAT_H
+
+/* Define to 1 if you have the <sys/types.h> header file. */
+//Not used #undef HAVE_SYS_TYPES_H
+
+/* Define to 1 if you have the <unistd.h> header file. */
+//Not used #undef HAVE_UNISTD_H
+
+/* Name of package */
+//Not used #undef PACKAGE
+
+/* Define to the address where bug reports for this package should be sent. */
+//Not used #undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+//Not used #undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+//Not used #undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+//Not used #undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+//Not used #undef PACKAGE_VERSION
+
+/* Define to 1 if you have the ANSI C header files. */
+//Not used #undef STDC_HEADERS
+
+/* Define to 1 to use type_info::name() for class names */
+#cmakedefine CPPUNIT_USE_TYPEINFO_NAME
+
+/* Version number of package */
+#cmakedefine CPPUNIT_VERSION