Index: src/sdrc/sdr.cpp
===================================================================
--- src/sdrc/sdr.cpp	(revision 1168)
+++ src/sdrc/sdr.cpp	(working copy)
@@ -1241,7 +1241,7 @@
 // Return Value			:
 // Comments				:
 void		CScriptContext::printDefine(CSymbol *s) {
-	if (settings & COMPILER_SURPRESS_DEFINITIONS) return ;
+	if (settings & COMPILER_SUPPRESS_DEFINITIONS) return ;
 
 	if (s->defFileName != NULL)
 		printf("%s \t(%s(%d)) \t-> %d in %s\n",s->symbolName,sourceFile,lineNo-1,s->defLineNo,s->defFileName);
@@ -1657,7 +1657,7 @@
 
 	compileError++;
 
-	if (CScriptContext::settings & COMPILER_SURPRESS_ERRORS) return;
+	if (CScriptContext::settings & COMPILER_SUPPRESS_ERRORS) return;
 
 	sprintf(tmp,"%s(%d) : error : %s",sourceFile,statementLineNo,mes);
 
@@ -1678,7 +1678,7 @@
 
 	compileWarning++;
 
-	if (settings & COMPILER_SURPRESS_WARNINGS) return;
+	if (settings & COMPILER_SUPPRESS_WARNINGS) return;
 
 	sprintf(tmp,"%s(%d) : warning : %s",sourceFile,statementLineNo,mes);
 
Index: src/sdrc/sdrc.cpp
===================================================================
--- src/sdrc/sdrc.cpp	(revision 1168)
+++ src/sdrc/sdrc.cpp	(working copy)
@@ -93,8 +93,8 @@
 static	char	*argumentIncludeDirectory		=			"-I";
 static	char	*argumentDefine					=			"-D";
 static	char	*argumentOutput					=			"-o";
-static	char	*argumentSurpressWarnings		=			"-nw";
-static	char	*argumentSurpressErrors			=			"-ne";
+static	char	*argumentSuppressWarnings		=			"-nw";
+static	char	*argumentSuppressErrors			=			"-ne";
 static	char	*argumentResolutionInfo			=			"-ri";
 static	char	*argumentHelp					=			"--help";
 static	char	*argumentPrintVersionInfo		=			"-v";
@@ -125,9 +125,9 @@
 
 	printf("%s <outname>\t: Output to \"outname\" \n",argumentOutput);
 
-	printf("%s\t\t: Surpress warnings\n",argumentSurpressWarnings);
+	printf("%s\t\t: Suppress warnings\n",argumentSuppressWarnings);
 
-	printf("%s\t\t: Surpress errors\n",argumentSurpressErrors);
+	printf("%s\t\t: Suppress errors\n",argumentSuppressErrors);
 
 	printf("%s\t\t: Display resolution info\n",argumentResolutionInfo);
 
@@ -178,7 +178,7 @@
 int main(int argc, char* argv[]) {
 	CScriptContext	*currentCompiler;
 	int				i;
-	int				settings	=	COMPILER_SURPRESS_DEFINITIONS;
+	int				settings	=	COMPILER_SUPPRESS_DEFINITIONS;
 	TSearchpath		*dsoPath;
 	CList<char *>	*sourceFiles;
 	char			*sourceFile;
@@ -206,12 +206,12 @@
 
 	// Process the arguments
 	for (i=1;i<argc;i++) {
-		if (strcmp(argv[i],argumentSurpressWarnings) == 0) {
-			settings	|=	COMPILER_SURPRESS_WARNINGS;
-		} else if (strcmp(argv[i],argumentSurpressErrors) == 0) {
-			settings	|=	COMPILER_SURPRESS_ERRORS;
+		if (strcmp(argv[i],argumentSuppressWarnings) == 0) {
+			settings	|=	COMPILER_SUPPRESS_WARNINGS;
+		} else if (strcmp(argv[i],argumentSuppressErrors) == 0) {
+			settings	|=	COMPILER_SUPPRESS_ERRORS;
 		} else if (strcmp(argv[i],argumentResolutionInfo) == 0) {
-			settings	&=	~COMPILER_SURPRESS_DEFINITIONS;
+			settings	&=	~COMPILER_SUPPRESS_DEFINITIONS;
 		} else if (strcmp(argv[i],argumentPrintVersionInfo) == 0) {
 			printVersion();
 			exit(1);
Index: src/sdrc/sdr.h
===================================================================
--- src/sdrc/sdr.h	(revision 1168)
+++ src/sdrc/sdr.h	(working copy)
@@ -87,9 +87,9 @@
 
 
 // Bit position definitions for the settings field of the CScriptContext
-const	int		COMPILER_SURPRESS_WARNINGS		=	1;
-const	int		COMPILER_SURPRESS_ERRORS		=	2;
-const	int		COMPILER_SURPRESS_DEFINITIONS	=	4;
+const	int		COMPILER_SUPPRESS_WARNINGS		=	1;
+const	int		COMPILER_SUPPRESS_ERRORS		=	2;
+const	int		COMPILER_SUPPRESS_DEFINITIONS	=	4;
 
 
 ////////////////////////////////////////////////////////////////
Index: src/sdrc2/sdrc.cpp
===================================================================
--- src/sdrc2/sdrc.cpp	(revision 1168)
+++ src/sdrc2/sdrc.cpp	(working copy)
@@ -97,8 +97,8 @@
 static	char	*argumentIncludeDirectory		=			"-I";
 static	char	*argumentDefine					=			"-D";
 static	char	*argumentOutput					=			"-o";
-static	char	*argumentSurpressWarnings		=			"-nw";
-static	char	*argumentSurpressErrors			=			"-ne";
+static	char	*argumentSuppressWarnings		=			"-nw";
+static	char	*argumentSuppressErrors			=			"-ne";
 static	char	*argumentResolutionInfo			=			"-ri";
 static	char	*argumentHelp					=			"--help";
 static	char	*argumentPrintVersionInfo		=			"-v";
@@ -129,9 +129,9 @@
 
 	printf("%s <outname>\t: Output to \"outname\" \n",argumentOutput);
 
-	printf("%s\t\t: Surpress warnings\n",argumentSurpressWarnings);
+	printf("%s\t\t: Suppress warnings\n",argumentSuppressWarnings);
 
-	printf("%s\t\t: Surpress errors\n",argumentSurpressErrors);
+	printf("%s\t\t: Suppress errors\n",argumentSuppressErrors);
 
 	printf("%s\t\t: Display resolution info\n",argumentResolutionInfo);
 